package rcarrilloco.PlanningFisio.fisioterapeutas;



import java.util.ArrayList;

import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ListView;
import rcarrilloco.PlanningFisio.R;
import rcarrilloco.PlanningFisio.library.Httppostaux;
import rcarrilloco.PlanningFisio.pacientes.NuevoPaciente;





public class ListadoFisiosPacientes extends Activity {
	Httppostaux post;
	ListView lista_fisios;
	EditText filterEditText;
	String dnif;
	int tipousuario;
	class paciente {
	    public String nombre;
	    public String apellidos;
	    public String dni;
	}
	ArrayList<String> arrayOfWebdata = new ArrayList<String>();
	ArrayList<String> arrayOfWebdni = new ArrayList<String>();
	String IP_Server="www.solucionatest.com";
    String URL_connect="http://"+IP_Server+"/campus/planningfisio/listado_fisios.php";
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_action_search, menu);
        return true;
    }
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            
            case R.id.menu_search:
                Log.i("ActionBar", "Buscar!");
                filterEditText.setVisibility(View.VISIBLE);
                filterEditText.setFocusable(true);
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }
    public void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.listadofisios);
        Bundle extras = getIntent().getExtras();
        tipousuario=extras.getInt("tipo_usuario");
        filterEditText = (EditText) findViewById(R.id.search_edit);
        new ListadoTask().execute();
 		}
 
    
    
    class ListadoTask extends AsyncTask<Void, Void, Void>{
    	 
 		@Override
        protected void onPreExecute() {
 			
        }
 
        @Override
        protected Void doInBackground(Void... JSONArray) {
        	post=new Httppostaux();

            ArrayList<NameValuePair> postparameters2send= new ArrayList<NameValuePair>();
      		
         	
     		postparameters2send.add(new BasicNameValuePair("dni_f",dnif));
     		
     		JSONArray jdata=post.getserverdata(postparameters2send, URL_connect);
    		if(jdata!=null)
    		{	
    		try {
    			for(int i=0; i<jdata.length();i++){
    			
					JSONObject json_data= jdata.getJSONObject(i);
					arrayOfWebdata.add(json_data.getString("nombre")+ " "+json_data.getString("apellidos"));
					arrayOfWebdni.add(json_data.getString("dni_f"));
					}
				} catch (JSONException e) {
					
				}
    		}else{arrayOfWebdata.add("No hay fisioterapeutas");
    		
    		}
    			
    	   return null;
        }
 
        @Override
        protected void onPostExecute(Void unused) {
        	lista_fisios = (ListView) findViewById(R.id.lista_pacientes);
        	final ArrayAdapter<String> adapter = new ArrayAdapter<String>(ListadoFisiosPacientes.this, android.R.layout.simple_list_item_1, arrayOfWebdata);
			
        	lista_fisios.setAdapter(adapter); 
        	
    		filterEditText.addTextChangedListener(new TextWatcher() {

    			public void onTextChanged(CharSequence s, int start, int before,
    					int count) {
    				adapter.getFilter().filter(s.toString());
    			}

    			
    			public void beforeTextChanged(CharSequence s, int start, int count,
    					int after) {
    			}

    			
    			public void afterTextChanged(Editable s) {
    			}
    		});
			lista_fisios.setOnItemClickListener(new OnItemClickListener(){
	        public void onItemClick(AdapterView<?> parent, View v, int posicion, long id) {
	        	if(arrayOfWebdata.get(posicion)!="No existen fisioterapeutas dados de alta"){
	        	   String Enviodni = arrayOfWebdni.get(posicion);
	                finish();
	                Intent i=new Intent(ListadoFisiosPacientes.this, NuevoPaciente.class);
	                i.putExtra("dni_f", Enviodni);
	                i.putExtra("tipo_usuario", tipousuario);
	    			startActivity(i); 
	            }
	        	else{
    				AlertDialog.Builder builder = new AlertDialog.Builder(ListadoFisiosPacientes.this);
			          builder.setTitle("Fisioterapeutas");
			          builder.setMessage("No existen fisioterapeutas. Desea crea uno?");
			          builder.setPositiveButton("SI", new DialogInterface.OnClickListener() {
			          public void onClick(DialogInterface dialogInterface, int i) {
			        	    finish();
			            	Intent i1=new Intent(ListadoFisiosPacientes.this, NuevoFisio.class);
			            	i1.putExtra("dni_f",dnif);
			            	startActivity(i1); 
			            }
			          });
			          builder.setNegativeButton("NO", new DialogInterface.OnClickListener() {
			              public void onClick(DialogInterface dialogInterface, int i) {
			            	finish();
			            	Intent i1=new Intent(ListadoFisiosPacientes.this, NuevoPaciente.class);
				            i1.putExtra("dni_f",dnif);
				            startActivity(i1); 
			                }
			              });
			          Dialog alertDialog = builder.create();
			          alertDialog.setCanceledOnTouchOutside(false);
			          alertDialog.show();
    			}
            }
        });		
    	return;
        }         
    }    

  
    
}	
        
        	
    
