package rcarrilloco.PlanningFisio.mapas;



import java.util.ArrayList;

import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.location.LocationManager;
import android.os.AsyncTask;
import android.os.Bundle;
import android.provider.Settings;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ListView;
import rcarrilloco.PlanningFisio.R;
import rcarrilloco.PlanningFisio.library.Httppostaux;


public class ListadoPacientesMapa extends Activity {
	Httppostaux post;
	ListView lista_pacientes;
	EditText filterEditText;
	String dnif=null;
	ArrayList<String> arrayOfWebdata = new ArrayList<String>();	
	ArrayList<String> arrayOfWebdireccion = new ArrayList<String>();	
	ArrayList<String> arrayOfCP = new ArrayList<String>();	
	ArrayList<String> arrayOfLocalidad = new ArrayList<String>();

	String IP_Server="www.solucionatest.com";
    String URL_connect="http://"+IP_Server+"/campus/planningfisio/listado_pacientes.php";
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_action_search, menu);
        return true;
    }
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.menu_search:
            	Log.i("ActionBar", "Buscar!");
                filterEditText.setVisibility(View.VISIBLE);
                filterEditText.setFocusable(true);
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }
    public void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.listadopacientes);
        Bundle extras = getIntent().getExtras();
        dnif=extras.getString("dni_f");
        filterEditText = (EditText) findViewById(R.id.search_edit);
        new ListadoTask().execute();
 		}
 
    class ListadoTask extends AsyncTask<Void, Void, Void>{
    	 
 		@Override
        protected void onPreExecute() {
 			Bundle extras = getIntent().getExtras();
 	        dnif=extras.getString("dni_f");
        }
 
        @Override
        protected Void doInBackground(Void... JSONArray) {
            post=new Httppostaux();

    		
 ArrayList<NameValuePair> postparameters2send= new ArrayList<NameValuePair>();
      		
         	
     		postparameters2send.add(new BasicNameValuePair("dni_f",dnif));
     		
      		JSONArray jdata=post.getserverdata(postparameters2send, URL_connect);
    		
    		try {
    			for(int i=0; i<jdata.length();i++){
    			
					JSONObject json_data= jdata.getJSONObject(i);
					arrayOfWebdata.add(json_data.getString("nombre")+ " "+json_data.getString("apellidos"));
					arrayOfWebdireccion.add(json_data.getString("direccion")+ ", "+json_data.getString("localidad")+ ", "+json_data.getString("cp")+" Espaa");
					arrayOfCP.add(json_data.getString("cp"));
					arrayOfLocalidad.add(json_data.getString("localidad")+", Espaa");
					}
    			} catch (JSONException e) {
					
				}
    			
    	   return null;
        }
 
        @Override
        protected void onPostExecute(Void unused) {
        	lista_pacientes = (ListView) findViewById(R.id.lista_pacientes);
        	final ArrayAdapter<String> adapter = new ArrayAdapter<String>(ListadoPacientesMapa.this, android.R.layout.simple_list_item_1, arrayOfWebdata);
			
        	lista_pacientes.setAdapter(adapter); 
        	
    		filterEditText.addTextChangedListener(new TextWatcher() {

    			
    			public void onTextChanged(CharSequence s, int start, int before,
    					int count) {
    				adapter.getFilter().filter(s.toString());
    			}

    			
    			public void beforeTextChanged(CharSequence s, int start, int count,
    					int after) {
    			}

    			
    			public void afterTextChanged(Editable s) {
    			}
    		});
			lista_pacientes.setOnItemClickListener(new OnItemClickListener(){
				
	        public void onItemClick(AdapterView<?> parent, View v, int posicion, long id) {
	                String direccion= arrayOfWebdireccion.get(posicion);
	                String cp=arrayOfCP.get(posicion);
	                String localidad=arrayOfLocalidad.get(posicion);
	                LocationManager lm = (LocationManager) getSystemService(LOCATION_SERVICE);
			        if(!lm.isProviderEnabled(LocationManager.GPS_PROVIDER) ||
			              !lm.isProviderEnabled(LocationManager.NETWORK_PROVIDER)) {
			          AlertDialog.Builder builder = new AlertDialog.Builder(ListadoPacientesMapa.this);
			          builder.setTitle("Servicio de localizacin no activos");
			          builder.setMessage("Desea habilitar los Servicios de Localicacin y el GPS");
			          builder.setPositiveButton("SI", new DialogInterface.OnClickListener() {
			          public void onClick(DialogInterface dialogInterface, int i) {
			          Intent intent = new Intent(Settings.ACTION_LOCATION_SOURCE_SETTINGS);
			            startActivity(intent);
			            }
			          });
			          builder.setNegativeButton("NO", new DialogInterface.OnClickListener() {
			              public void onClick(DialogInterface dialogInterface, int i) {
			            	  AlertDialog.Builder builder = new AlertDialog.Builder(ListadoPacientesMapa.this);
			            	  builder.setTitle("Servicio de localizacin no activos");
					          builder.setMessage("Si no activa los Servicios de Localicacin y el GPS no podr usar esta funcin");
					          builder.setCancelable(true);
					          builder.show();
			                }
			              });
			          Dialog alertDialog = builder.create();
			          alertDialog.setCanceledOnTouchOutside(false);
			          alertDialog.show();
			        }else{
	                
	               Intent i=new Intent(ListadoPacientesMapa.this, Mapa.class);
	               i.putExtra("dni_f", dnif);
	               i.putExtra("direccion", direccion);
	               i.putExtra("cp", cp);
	               i.putExtra("localidad", localidad);
	               startActivity(i); 
			        	}
	            }
	        });		
        	return;
        	
        }         
    }    

  
    
}	
        
        	
    

  
