package rcarrilloco.PlanningFisio.mapas;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Document;

import rcarrilloco.PlanningFisio.R;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.maps.model.PolylineOptions;
import android.app.AlertDialog;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.location.Address;
import android.location.Geocoder;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.util.Log;
import android.widget.Toast;

public class Mapa extends FragmentActivity {
	GoogleMap mMap;
    GuiarA md;
    public String Longitud;
	public String Latitud;
    public String domiciliopaciente;
	public String cp;	
	public String localidad;	
	public String dnif;   
    public LatLng posicionactual;   
    public LatLng posiciondestino;   
    public List<Address> foundGeocode = null;
    public List<Address> foundGeocode1 = null;
    private LocationManager locManager;   	
   	private LocationListener locListener;
	
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.mapa);
        Bundle extras = getIntent().getExtras();
        dnif=extras.getString("dni_f");
        domiciliopaciente=extras.getString("direccion");
        cp=extras.getString("cp");
        localidad=extras.getString("localidad");
        md = new GuiarA();
		mMap = ((SupportMapFragment)getSupportFragmentManager()
						.findFragmentById(R.id.map)).getMap();
		comenzarLocalizacion();
		
		try {
			foundGeocode = new Geocoder(this).getFromLocationName(domiciliopaciente, 1);
			foundGeocode1 = new Geocoder(this).getFromLocationName(localidad, 1);
			String codigopostal=foundGeocode.get(0).getPostalCode();
			String localidadpaciente1=foundGeocode1.get(0).getLocality()+", "+ foundGeocode1.get(0).getCountryName();
			
			if(cp.equals(codigopostal))
				posiciondestino = new LatLng(foundGeocode.get(0).getLatitude(),foundGeocode.get(0).getLongitude());
			else if (localidad.equals(localidadpaciente1)){
				 posiciondestino = new LatLng(foundGeocode1.get(0).getLatitude(),foundGeocode1.get(0).getLongitude());
				 AlertDialog.Builder builder = new AlertDialog.Builder(Mapa.this);
		         builder.setTitle("Error en la direccin");
		         builder.setMessage("No se ha podido localizar la direccin de paciente, compruebe que es correcta. Ha sido guiado al centro de la poblacin");
		         builder.setCancelable(true);
		         builder.show();
		         Intent i=new Intent(Mapa.this, ListadoPacientesMapa.class);
	             i.putExtra("dni_f", dnif);
			}else{
				 posiciondestino = posicionactual;
				 AlertDialog.Builder builder = new AlertDialog.Builder(Mapa.this);
		         builder.setTitle("Error en la direccin");
		         builder.setMessage("No se ha podido localizar la direccin de paciente, compruebe que es correcta");
		         builder.setCancelable(true);
		         builder.show();
		         Intent i=new Intent(Mapa.this, ListadoPacientesMapa.class);
	             i.putExtra("dni_f", dnif);
			}
			} catch (IOException e) {
			  Log.d("ERROR","NO ENCUENTRA LAS COORDENADAS");
            e.printStackTrace();
			}
		
       
        
        mMap.setMyLocationEnabled(true);
		LatLng coordinates = posicionactual;		
		mMap.animateCamera(CameraUpdateFactory.newLatLngZoom(coordinates, 12));
		
		mMap.addMarker(new MarkerOptions().position(posicionactual).title("Su situacin").snippet("Localizacin del Fisioterapeuta").icon(BitmapDescriptorFactory.fromResource(R.drawable.ic_launcher)));
		mMap.addMarker(new MarkerOptions().position(posiciondestino).title("Destino"));
		
		Document doc = md.getDocument(posicionactual, posiciondestino, GuiarA.MODE_DRIVING);
		int duration = md.getDurationValue(doc);
		String distance = md.getDistanceText(doc);
		String start_address = md.getStartAddress(doc);
		String copy_right = md.getCopyRights(doc);
       		ArrayList<LatLng> directionPoint = md.getDirection(doc);
		PolylineOptions rectLine = new PolylineOptions().width(5).color(Color.BLUE);
		
		for(int i = 0 ; i < directionPoint.size() ; i++) {			
			rectLine.add(directionPoint.get(i));
		}
		
		mMap.addPolyline(rectLine);
    }
	
	
	private void comenzarLocalizacion()
    {
    	locManager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
    	Location loc = locManager.getLastKnownLocation(LocationManager.GPS_PROVIDER);
    	
    	mostrarPosicion(loc);
    	
    	locListener = new LocationListener() {
	    	public void onLocationChanged(Location location) {
	    		mostrarPosicion(location);
	    	}

			public void onProviderDisabled(String provider) {
				Toast.makeText( getApplicationContext(),"Gps Desactivado",Toast.LENGTH_SHORT ).show();
				
			}

			public void onProviderEnabled(String provider) {
				Toast.makeText( getApplicationContext(),"Gps Activo",Toast.LENGTH_SHORT ).show();
				
			}

			public void onStatusChanged(String provider, int status,
					Bundle extras) {
				
			}    	
	    	
    	};
    	
    	locManager.requestLocationUpdates(
    			LocationManager.GPS_PROVIDER, 30000, 0, locListener);
    }
     
    private void mostrarPosicion(Location loc) {
    	if(loc != null)
    	{
    		Latitud =  String.valueOf(loc.getLatitude());
    		Longitud = String.valueOf(loc.getLongitude());
    		posicionactual= new LatLng(loc.getLatitude(),loc.getLongitude());
    	}
    }
}

