package rcarrilloco.PlanningFisio.pacientes;



import java.util.ArrayList;

import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ListView;
import rcarrilloco.PlanningFisio.MFisioterapeuta;
import rcarrilloco.PlanningFisio.R;
import rcarrilloco.PlanningFisio.fisioterapeutas.ListadoFisiosPacientes;
import rcarrilloco.PlanningFisio.library.Httppostaux;




public class ListadoPacientes extends Activity {
	Httppostaux post;
	ListView lista_pacientes;
	EditText filterEditText;
	int tipousuario;
	String dnif=null;
	ArrayList<String> arrayOfWebdata = new ArrayList<String>();
	ArrayList<String> arrayOfWebdni = new ArrayList<String>();
	String IP_Server="www.solucionatest.com";
	String URL_connect="http://"+IP_Server+"/campus/planningfisio/listado_pacientes.php";
    String URL_connect1="http://"+IP_Server+"/campus/planningfisio/listado_pacientes_total.php";
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
         getMenuInflater().inflate(R.menu.menu_action_list, menu);
        return true;
    }
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.menu_new:
            	finish();
            	if(tipousuario==1){
            	Intent i=new Intent(ListadoPacientes.this, NuevoPaciente.class);
            	i.putExtra("dni_f",dnif);
            	i.putExtra("tipo_usuario",tipousuario);
    			startActivity(i); 
            	}else{
            		Intent i=new Intent(ListadoPacientes.this, ListadoFisiosPacientes.class);
            		i.putExtra("tipo_usuario",tipousuario);
                	startActivity(i); 
            	}
                return true;
            case R.id.menu_search:
            	Log.i("ActionBar", "Buscar!");
                filterEditText.setVisibility(View.VISIBLE);
                filterEditText.setFocusable(true);
                return true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }
    public void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.listadopacientes);
        Bundle extras = getIntent().getExtras();
        dnif=extras.getString("dni_f");
        tipousuario=extras.getInt("tipo_usuario");
        filterEditText = (EditText) findViewById(R.id.search_edit);
        if(tipousuario==1)
        {
        new ListadoTask().execute();
        }else if(tipousuario==2) {
        	new ListadoTask1().execute();}
 		}
 
    
    
    class ListadoTask extends AsyncTask<Void, Void, Void>{
    	 
 		@Override
        protected void onPreExecute() {
 			Bundle extras = getIntent().getExtras();
 	        dnif=extras.getString("dni_f");
        }
 
        @Override
        protected Void doInBackground(Void... JSONArray) {
            post=new Httppostaux();

            ArrayList<NameValuePair> postparameters2send= new ArrayList<NameValuePair>();
      		
         	
     		postparameters2send.add(new BasicNameValuePair("dni_f",dnif));
     		
      		JSONArray jdata=post.getserverdata(postparameters2send, URL_connect);
    		if(jdata!=null)
    		{	
    		try {
    			for(int i=0; i<jdata.length();i++){
    			
					JSONObject json_data= jdata.getJSONObject(i);
					arrayOfWebdata.add(json_data.getString("nombre")+ " "+json_data.getString("apellidos"));
					arrayOfWebdni.add(json_data.getString("dni"));
					}
    			} catch (JSONException e) {
					
				}
    		}else{arrayOfWebdata.add("No hay pacientes para este fisio");
    		
    		}
    		
    	   return null;
        }
 
        @Override
        protected void onPostExecute(Void unused) {
        	lista_pacientes = (ListView) findViewById(R.id.lista_pacientes);
        	final ArrayAdapter<String> adapter = new ArrayAdapter<String>(ListadoPacientes.this, android.R.layout.simple_list_item_1, arrayOfWebdata);
			
        	lista_pacientes.setAdapter(adapter); 
        	
    		filterEditText.addTextChangedListener(new TextWatcher() {

    			public void onTextChanged(CharSequence s, int start, int before,
    					int count) {
    				adapter.getFilter().filter(s.toString());
    			}

    			
    			public void beforeTextChanged(CharSequence s, int start, int count,
    					int after) {
    			}

    			
    			public void afterTextChanged(Editable s) {
    			}
    		});
			lista_pacientes.setOnItemClickListener(new OnItemClickListener(){
	        public void onItemClick(AdapterView<?> parent, View v, int posicion, long id) {
	        	if(arrayOfWebdata.get(posicion)!="No hay pacientes para este fisio"){
	        	   String dni = arrayOfWebdni.get(posicion);
	                finish();
	                Intent i=new Intent(ListadoPacientes.this, RecuperarPaciente.class);
	                i.putExtra("dni", dni);
	                i.putExtra("dni_f", dnif);
	                i.putExtra("tipo_usuario",tipousuario);
	    			startActivity(i); 
	            }
	        	else{
    				AlertDialog.Builder builder = new AlertDialog.Builder(ListadoPacientes.this);
			          builder.setTitle("Pacientes del fisioterapeuta");
			          builder.setMessage("No existen pacientes para ste fisioterapeuta. Desea crea uno?");
			          builder.setPositiveButton("SI", new DialogInterface.OnClickListener() {
			          public void onClick(DialogInterface dialogInterface, int i) {
			        	    finish();
			            	Intent i1=new Intent(ListadoPacientes.this, NuevoPaciente.class);
			            	i1.putExtra("dni_f",dnif);
			            	i1.putExtra("tipo_usuario",tipousuario);
			            	startActivity(i1); 
			            }
			          });
			          builder.setNegativeButton("NO", new DialogInterface.OnClickListener() {
			              public void onClick(DialogInterface dialogInterface, int i) {
			            	finish();
			            	Intent i1=new Intent(ListadoPacientes.this, MFisioterapeuta.class);
				            i1.putExtra("dni_f",dnif);
				            i1.putExtra("tipo_usuario",tipousuario);
				            startActivity(i1); 
			                }
			              });
			          Dialog alertDialog = builder.create();
			          alertDialog.setCanceledOnTouchOutside(false);
			          alertDialog.show();
    			}
            }
        });		
    	return;
        	
        }         
    }    

    
    class ListadoTask1 extends AsyncTask<Void, Void, Void>{
   	 
 		@Override
        protected void onPreExecute() {
 			Bundle extras = getIntent().getExtras();
 	        dnif=extras.getString("dni_f");
        }
 
        @Override
        protected Void doInBackground(Void... JSONArray) {
            post=new Httppostaux();

            ArrayList<NameValuePair> postparameters2send= new ArrayList<NameValuePair>();
      		
         	
     		postparameters2send.add(new BasicNameValuePair("dni_f",dnif));
     		
      		JSONArray jdata=post.getserverdata(postparameters2send, URL_connect1);
    		if(jdata!=null)
    		{	
    		try {
    			for(int i=0; i<jdata.length();i++){
    			
					JSONObject json_data= jdata.getJSONObject(i);
					arrayOfWebdata.add(json_data.getString("nombre")+ " "+json_data.getString("apellidos"));
					arrayOfWebdni.add(json_data.getString("dni"));
					}
				} catch (JSONException e) {
					
				}
    		}else{arrayOfWebdata.add("No hay pacientes para este fisio");
    		
    		}
    		
    	   return null;
        }
 
        @Override
        protected void onPostExecute(Void unused) {
        	lista_pacientes = (ListView) findViewById(R.id.lista_pacientes);
        	final ArrayAdapter<String> adapter = new ArrayAdapter<String>(ListadoPacientes.this, android.R.layout.simple_list_item_1, arrayOfWebdata);
			
        	lista_pacientes.setAdapter(adapter); 
        	
    		filterEditText.addTextChangedListener(new TextWatcher() {

    			public void onTextChanged(CharSequence s, int start, int before,
    					int count) {
    				adapter.getFilter().filter(s.toString());
    			}

    			
    			public void beforeTextChanged(CharSequence s, int start, int count,
    					int after) {
    			}

    			
    			public void afterTextChanged(Editable s) {
    			}
    		});
			lista_pacientes.setOnItemClickListener(new OnItemClickListener(){
	        public void onItemClick(AdapterView<?> parent, View v, int posicion, long id) {
	        	if(arrayOfWebdata.get(posicion)!="No hay pacientes para este fisio"){
	        	   String dni = arrayOfWebdni.get(posicion);
	                finish();
	                Intent i=new Intent(ListadoPacientes.this, RecuperarPaciente.class);
	                i.putExtra("dni", dni);
	                i.putExtra("dni_f", dnif);
	                i.putExtra("tipo_usuario",tipousuario);
	    			startActivity(i); 
	            }
	        	else{
    				AlertDialog.Builder builder = new AlertDialog.Builder(ListadoPacientes.this);
			          builder.setTitle("Pacientes del fisioterapeuta");
			          builder.setMessage("No existen pacientes para ste fisioterapeuta. Desea crea uno?");
			          builder.setPositiveButton("SI", new DialogInterface.OnClickListener() {
			          public void onClick(DialogInterface dialogInterface, int i) {
			        	    finish();
			            	Intent i1=new Intent(ListadoPacientes.this, NuevoPaciente.class);
			            	i1.putExtra("dni_f",dnif);
			            	startActivity(i1); 
			            }
			          });
			          builder.setNegativeButton("NO", new DialogInterface.OnClickListener() {
			              public void onClick(DialogInterface dialogInterface, int i) {
			            	finish();
			            	Intent i1=new Intent(ListadoPacientes.this, MFisioterapeuta.class);
				            i1.putExtra("dni_f",dnif);
				            startActivity(i1); 
			                }
			              });
			          Dialog alertDialog = builder.create();
			          alertDialog.setCanceledOnTouchOutside(false);
			          alertDialog.show();
    			}
            }
        });		
    	return;
        }         
    }    

  
    
}	
        
        	
    

  
